<?php

namespace App\Policies;

use App\Models\Rata;
use App\Models\User;
use Illuminate\Auth\Access\Response;

class RataPolicy
{
    /**
     * Determine whether the user can view any models.
     */
    public function viewAny(User $user): bool
    {
        return $user->hasRole(['admin', 'amministratore']);
    }

    /**
     * Determine whether the user can view the model.
     */
    public function view(User $user, Rata $rata): bool
    {
        if ($user->hasRole('admin')) {
            return true;
        }

        if ($user->hasRole('amministratore')) {
            return $rata->pianoRateizzazione->ripartizioneSpese->voceSpesa->stabile->amministratore_id === $user->amministratore->id_amministratore;
        }

        return false;
    }

    /**
     * Determine whether the user can create models.
     */
    public function create(User $user): bool
    {
        return $user->hasRole(['admin', 'amministratore']);
    }

    /**
     * Determine whether the user can update the model.
     */
    public function update(User $user, Rata $rata): bool
    {
        if ($user->hasRole('admin')) {
            return true;
        }

        if ($user->hasRole('amministratore')) {
            return $rata->pianoRateizzazione->ripartizioneSpese->voceSpesa->stabile->amministratore_id === $user->amministratore->id_amministratore;
        }

        return false;
    }

    /**
     * Determine whether the user can delete the model.
     */
    public function delete(User $user, Rata $rata): bool
    {
        if ($user->hasRole('admin')) {
            return true;
        }

        if ($user->hasRole('amministratore')) {
            return $rata->pianoRateizzazione->ripartizioneSpese->voceSpesa->stabile->amministratore_id === $user->amministratore->id_amministratore;
        }

        return false;
    }

    /**
     * Determine whether the user can restore the model.
     */
    public function restore(User $user, Rata $rata): bool
    {
        return $this->delete($user, $rata);
    }

    /**
     * Determine whether the user can permanently delete the model.
     */
    public function forceDelete(User $user, Rata $rata): bool
    {
        return $user->hasRole('admin');
    }
}
